
export function FindLansaContext() {

    let parentDOM = (window && window.opener && window.opener.document) || null;
    let webroutineoutput = "";
    let objContextStr = "";
    let objContext = null;
    let patternToSearchStart = "LANSA.useOutput";
    let patternToSearchEnd = "});";
    
    if (parentDOM == null)
    {
        return null;
    }
    
    for (let i = 0; i < parentDOM.scripts.length; i++) 
    {
	    if ( (parentDOM.scripts[i].innerText != undefined) && (parentDOM.scripts[i].innerText.indexOf("session-key") > 0 ) )
        {
		    webroutineoutput = parentDOM.scripts[i].innerText;
		    break;
    	}
    }

    let p1 = webroutineoutput.indexOf(patternToSearchStart);

    if (p1 >= 0)
    {
        let p2 = webroutineoutput.indexOf(patternToSearchEnd, p1);

        try
        {
            objContextStr = webroutineoutput.substring(p1 + 16, p2 + 1);
            let parsedContent = JSON.parse(objContextStr);

            objContext = parsedContent.webroutine.context;

        } catch(e)
        {
            objContext = null;
        }   
    }

    return objContext;

}


export function MakeFormEncodedBody(srcRequestData) {
    
    let requestbody = ""
    
    // =================================================
    // FIELDS 
    //
    // [FieldName]=[FieldValue]
    // =================================================

    let idx = 0
    for (let f in srcRequestData.fields)
    {
        //requestbody += (idx == 0 ? "" : "&") + f + '=' + encodeURIComponent(srcRequestData.fields[f].value)
        requestbody += (idx == 0 ? "" : "&") + f + '=' + srcRequestData.fields[f].value
        idx++;
    }

    // ===============================================================================
    // LISTS 
    // 
    // [ListName]..=1 
    // [ListName].[recnumber].[FieldName]=[FieldValue]
    // ===============================================================================
    
    for (let l in srcRequestData.lists)
    {
        if (requestbody != "")
        {
            requestbody += "&" 
        }
        
        requestbody += l + "..=1"

        let r = 1
        for (let rec in srcRequestData.lists[l].entries)
        {
            for (let c in srcRequestData.lists[l].entries[rec])
            {
                let v = "&" + l + "." + r.toString() + "." + srcRequestData.lists[l].headers[c].name + "=" + encodeURIComponent(srcRequestData.lists[l].entries[rec][c])
                requestbody += v
            }
            r++
        }
    }

    return requestbody
}


export function MakeVoidStatus() {
    return {
        code: "OK",
        message: "",
        messageid: ""
    }
}

export function MakeGoodStatus() {
    return {
        code: "OK",
        message: "",
        messageid: ""
    }
}


export function MakeBadStatus(code, message, messageId) {
    return {
        code: code || "ER",
        message: message || "",
        messageid: messageId || ""
    }
}