const path = require('path');
const webpack = require('webpack');

function resolve (dir) {
    return path.join(__dirname, '..', dir)
}
  

module.exports = {
  entry: './index.js',
  output: {
    path: path.resolve(__dirname, 'dist/'),
    filename: 'lansa-vue-plugin.js',
    sourceMapFilename: 'lansa-vue-plugin.map',
    library: 'lansa-vue-plugin',
    libraryTarget: 'umd'
  },
  node: {
    process: false
  },
  devtool: 'source-map',
  module: {
    rules: [
      {
        test: /\.js$/,
        exclude: /(node_modules|bower_components)/,
        use: {
          loader: 'babel-loader',
        }
      }
    ]
  }  
}
